#ifndef __HEADER_IFPOLLD__
#define __HEADER_IFPOLLD__

#include "../ifpollLib/ifftn.h"
#include "../ifpollLib/_semshm.h"


#define CALL_PRESENT_NOCALL_FILE   0
#define CALL_NO_NOW                1
#define CALL_ERROR                 4
#define CALL_SUCCESFULL            5
#define CALL_NO_PHONE		   6	



extern char  *_ifcico   ;        /*  */
extern char  *_inbound  ;
extern int   _delayCall  ;     /*    */
extern int   _delayZeroQueue;    /*     */
extern char  *_script  ;





class ftn_queue
{
   protected:
      int           flagBeAnyCall;
      int           delayNow;
      
   public:
      ftn_node	    **node;
      int           countNode;
      int           currentNode;
      MESSAGE_TYPE  message;
      key_t         key;
      int           msgid;
      pid_t         pidIfcico;
      int           flagDoCall;
      int           flagDelayCall;
      int           flagReRead;
      int           statusCurrNode;
      
      FILE          *fpIfcicoLog;
      semshm_obj    *semshm;
      emsi_and_info_type infoEmsi;

   protected:
      void AddNodeInList        ( void );
      void RemoveAllNodeFromList( void );
      int  TestMaska            ( char *maska );
      void GetAndStartScript    ( char *str );      
	          
   public:
      ftn_queue();
      ~ftn_queue();
      
      void Rescan( void );
      int TestDoubleNode( address_type *addr );

      void Work( void );
      int AnalysReturnCode( ftn_node *currNode, int code );
      void RestoreFloClo( void );
      void ScanScript( void );
      
      int  CreateQueueMessages ( void );
      void DestroyQueueMessages( void );
      int  ServerTestInputMessage   ( void );
      void ServerDispetcher( void );
      void ServerSendReport    ( long type );

      void ClientSendInquiry  ( int codCommand );
      int  ClientReceiveReport( long type );
      
      void ShowQueue   ( void );
      void ShowInfoNode( char *str );
      void ShowDelay   ( void );
      
      void SetStatus ( char *str );      
      void SetOutCall( char *str );
      void SetDelay  ( char *str );
      
      void ReportQueue    ( void );
      void ReportInfoNode ( void );
      void ReportInfoNodeIndex( void );
      void ReportDelay    ( void );
      void ReportSetStatusIndex( void );
      void ReportSetStatus( void );
      void ReportHangUp   ( void );
      void ReportSetDelay ( void ); 
      void ReportDeleteNodeIndex( void );      
      void ReportDeleteNode( void );
      void ReportRereadLog( void );
      
      void DeleteNode( char *str );
      
      void Poll( char *str );
      
      int Call( void );
      
      void Sleep( int sec );
      
      void OpenLogIfcico ( void );
      void ScanLogIfcico ( void );
      void CloseLogIfcico( void );
      char *FormLogString( char *str );
      void AnalysLogStringIfcico( char *str );
      
};

extern ftn_queue  queue;

#endif
